package com.grizzly.test.arp.server;

import java.io.IOException;

import com.sun.grizzly.arp.AsyncExecutor;
import com.sun.grizzly.arp.AsyncFilter;
import com.sun.grizzly.arp.AsyncHandler;
import com.sun.grizzly.arp.AsyncTask;
import com.sun.grizzly.arp.DefaultAsyncHandler;
import com.sun.grizzly.http.DefaultProcessorTask;
import com.sun.grizzly.http.SelectorThread;
import com.sun.grizzly.tcp.Request;

/**
 * Original code comes from http://kasparov.skife.org/blog/src/java/grizzly-arp-basic.html
 * 
 * @author Brian McCallister
 */
public class SimpleArpServer
{
	public static final String CALLBACK_KEY = "org.skife.grizzly.FINISH_REQUEST";

	public static void main(String[] args) throws IOException, InstantiationException
	{
		SelectorThread sel = new SelectorThread();
		sel.setPort(8080);

		sel.setAdapter(new ViewAdapter());

		final AsyncHandler handler = new DefaultAsyncHandler();
		handler.addAsyncFilter(new AsyncFilter()
		{
			public boolean doFilter(final AsyncExecutor executor)
			{
				final AsyncTask asyncTask = executor.getAsyncTask();
				final AsyncHandler asyncHandler = executor.getAsyncHandler();

				final DefaultProcessorTask processorTask = (DefaultProcessorTask) executor.getProcessorTask();
				Request req = processorTask.getRequest();
				if (req.requestURI().toString().equals("/refreshView"))
				{
					req.setAttribute(CALLBACK_KEY, new Runnable()
					{
						public void run()
						{
							asyncHandler.handle(asyncTask);
						}
					});
					processorTask.invokeAdapter();
					return false;
				}
				return true;
			}
		});
		sel.setAsyncHandler(handler);
		sel.setEnableAsyncExecution(true);
		sel.setDisplayConfiguration(true);
		sel.initEndpoint();
		sel.startEndpoint();
	}
}
